# Define the kmod package name here.
%define kmod_name wl

# Define the Broadcom tarball name here.
%define bcom_name hybrid-portsrc

# If kversion isn't defined on the rpmbuild line, define it here as the currently running kernel.
%{!?kversion: %define kversion $(uname -r)}

Name:    %{kmod_name}-kmod
Version: 5_100_82_112
Release: 4.el6%{?dist}
Group:   System Environment/Kernel
License: Broadcom
Summary: %{kmod_name} kernel module(s)
URL:     http://www.broadcom.com/support/802.11/linux_sta.php

BuildRequires: redhat-rpm-config
ExclusiveArch: i686 x86_64

# Sources.
Source0:  %{bcom_name}_x86_32-v%{version}.tar.gz
Source1:  %{bcom_name}_x86_64-v%{version}.tar.gz
Source2:  README.txt
Source10: kmodtool-%{kmod_name}-el6.sh

# Ensure that the proprietary tarballs ARE NOT packaged.
NoSource: 0
NoSource: 1

# Magic hidden here.
%{expand:%(sh %{SOURCE10} rpmtemplate %{kmod_name} %{kversion} "")}

# Disable the building of the debug package(s).
%define debug_package %{nil}

%description
This package provides the Broadcom hybrid %{kmod_name} kernel module(s).
It is built to depend upon the specific ABI provided by a range of releases
of the same variant of the Linux kernel and not on any one specific build.

%prep
%setup -q -n %{kmod_name}-kmod-%{version} -c -T
%ifarch i686
%setup -q -D -T -a 0
%endif
%ifarch x86_64
%setup -q -D -T -a 1
%endif
# Perform a necessary edit to the Broadcom Makefile.
%{__sed} -i 's/\/lib\/modules\/`uname -r`\/build/\"\${KSRC}\"/' Makefile
# Perform a necessary edit to src/wl/sys/wl_cfg80211.c
%{__sed} -i 's/.. KERNEL_VERSION(2, 6, 3.)/>= KERNEL_VERSION(2, 6, 32)/' src/wl/sys/wl_cfg80211.c
# Create the module override file.
echo "override %{kmod_name} * weak-updates/%{kmod_name}" > kmod-%{kmod_name}.conf
# Create the file to blacklist certain modules.
%{__cat} <<EOF > blacklist-Broadcom.conf
blacklist b43
blacklist b43legacy
blacklist bcm43xx
blacklist ssb
EOF
# Create the file to modprobe the modules at system initialisation time.
%{__cat} <<EOF > kmod-%{kmod_name}.modules
#!/bin/bash

for M in lib80211 cfg80211 wl; do
    modprobe $M &>/dev/null
done
EOF

%build
%{__make} KSRC=%{_usrsrc}/kernels/%{kversion}

%install
%{__install} -d %{buildroot}/lib/modules/%{kversion}/extra/%{kmod_name}/
%{__install} %{kmod_name}.ko %{buildroot}/lib/modules/%{kversion}/extra/%{kmod_name}/
%{__install} -d %{buildroot}%{_sysconfdir}/depmod.d/
%{__install} kmod-%{kmod_name}.conf %{buildroot}%{_sysconfdir}/depmod.d/
%{__install} -d %{buildroot}%{_sysconfdir}/modprobe.d/
%{__install} blacklist-Broadcom.conf %{buildroot}%{_sysconfdir}/modprobe.d/
%{__install} -d %{buildroot}%{_sysconfdir}/sysconfig/modules/
%{__install} kmod-%{kmod_name}.modules %{buildroot}%{_sysconfdir}/sysconfig/modules/
%{__install} -d %{buildroot}%{_defaultdocdir}/kmod-%{kmod_name}-%{version}/
%{__install} %{SOURCE2} %{buildroot}%{_defaultdocdir}/kmod-%{kmod_name}-%{version}/
%{__install} lib/LICENSE.txt %{buildroot}%{_defaultdocdir}/kmod-%{kmod_name}-%{version}/
# Set the module(s) to be executable, so that they will be stripped when packaged.
find %{buildroot} -type f -name \*.ko -exec %{__chmod} u+x \{\} \;
# Remove the unrequired files.
%{__rm} -f %{buildroot}/lib/modules/%{kversion}/modules.*

%clean
%{__rm} -rf %{buildroot}

%changelog
* Fri Jul 13 2012 The Doctor <DrWho@Gallifrey.Kasterborus> - 5_100_82_112-4
- Patched wl_cfg80211.c for EL6. [P J Welsh][http://elrepo.org/bugs/view.php?id=286]

* Sun Mar 18 2012 The Doctor <DrWho@Gallifrey.Kasterborus> - 5_100_82_112-3
- Re-wrote this spec file. [Yves Delannoy][http://elrepo.org/bugs/view.php?id=238]

* Wed Feb 29 2012 The Doctor <DrWho@Gallifrey.Kasterborus> - 5_100_82_112-2
- Added API=CFG80211 to the make modules line. [janne][http://elrepo.org/bugs/view.php?id=238]

* Thu Oct 27 2011 The Doctor <DrWho@Gallifrey.Kasterborus> - 5_100_82_112-1
- Updated to use the 5_100_82_112 tarballs.
- Blacklisted the bcm43xx module.

* Fri Jul 08 2011 The Doctor <DrWho@Gallifrey.Kasterborus> - 5_100_82_38-3
- Hard-coded a ".el6" as part of the %%{release} tag.

* Wed Jun 01 2011 The Doctor <DrWho@Gallifrey.Kasterborus> - 5_100_82_38-2
- Allow building for the currently running kernel, by default.
- Blacklist the interfering modules.

* Tue May 31 2011 The Doctor <DrWho@Gallifrey.Kasterborus> - 5_100_82_38-1
- Initial el6 build of the kmod package.
